#pragma once

#include "st7735s.h"

//        F, H, D  ..
enum vrows{F_ROW=4, H_ROW=6, D_ROW=8, T_ROW=10, I_ROW=12};

//       (  
// display.cpp).

//    ;   :
//   - , 
//   LCD;
//  , ,  RAM,    ;
//     .
int display_init();

//      (  
//  ).
// row, col -    ,    ;
// a -  ;
// nd -  ,      
//   ;
// xp - ,  3        
//  (..., -3 - , 0 -  , 3 - , ...);
// sfx -      
//  (0   ,     );
// force_sign -     true,   
//     (-),     (+).
void display_print(int row, int col, float a, uint32_t nd, int xp, char *sfx, bool force_sgn=false);

//     (   );
//   row,    col    .
void display_print_blank(int row, int col);

//      a  
// a=b*10**xp,
//  xp  3,
// 1<=b<1000.
int get_xp(float a);

//      a  
// a=b*10**xp,  xp  3.
//     ,   
//   b:
// 0.9<b<1100;
//      ,   
//  (a)  " "    (a_prev).
int get_xp(float a, float a_prev);

// ,      
//   (    display.cpp).
extern Display display_device;
