/*
***********************************************************************
     8..24
(       
        ).

: PD2 (TIM3_ETR),
 TTL/CMOS  (     5).

   :    
  ,    1   
    .

  MCU: STM32F100RB;  8;   24.

       
 TIM3 (  8,     
  ):
   
fmin=8/tau,
 tau -  .

       
      ( ,
         
),    (TIM4, TIM1 - 
  TIM15, TIM2 -  ).

     
  (TIM6, TIM7),    
      
   (   ).
***********************************************************************

   (TIM16)     
    (   
),      .

    .    
   TIM17 ( PB9). ().

     
  ,    .

main.cpp
   ,     
   (  main)   .
 main      
 .
  ,       
,      
 -        
 (   control.cpp).
*/

#include "stm32f10x.h"
#include "st7735s.h"
#include "control.h"

// TODO: exclude
// #include <string.h>


//     
//(  display.cpp).
int display_init();
//int display(uint32_t fclk, uint32_t m, uint32_t n);

//      16- 
//  (ARR+1,   ARR=0xFFFF).
#define CNT_OVR 0x10000

//      .
class Data
{
public:
	//      .
	uint32_t m;
	//      .
	uint32_t n;
};

//       ;
//      ;   ,
//         1 
//  ,       (  
//      -   
//     ,   
//   ).
//        .
class DBuf
{
private:
	//     .
	Data *p0;
	//      .
	Data *p;
	//   ,   .
	uint32_t m_size;
	//     .
	uint32_t cnt;
	// , ,     
	//  .
	bool full;
public:
	// ,  ,    
	//       .
	bool is_ready;
	//      32-  
	//         
	//  (   ).
	uint32_t c0;

	DBuf() : p0(0), p(0), m_size(0), cnt(0), full(false),
			is_ready(false), c0(0) {}

	DBuf(uint32_t _size) : p0(0), p(0), m_size(0), cnt(0),
			full(false), is_ready(false), c0(0)
	{
		if(_size != 0)
		{
			p = p0 = new Data[_size];
			m_size = _size;
		}
	}

	//       .
	void clear() volatile
	{
		delete[] p0;
		p0 = 0;
		p = 0;
		m_size = 0;
		cnt = 0;
		full = false;
		is_ready = false;
		c0 = 0;
	}

	//          .
	void reset(uint32_t _size) volatile
	{
		clear();
		if(_size != 0)
		{
			p = p0 = new Data[_size];
			m_size = _size;
		}
	}

	//  true,     
	//  .
	inline bool is_full() const volatile {return full;}

	//      .
	inline uint32_t get_cnt() const volatile {return cnt;}

	//      .
	uint32_t size() const volatile
	{
		return (full) ? m_size : p-p0;
	}

	//      .
	inline uint32_t max_size() const volatile {return m_size;}

	//     ;    - 
	//        1  (
	//   )       .
	void push(const Data &d) volatile
	{
		if(m_size != 0)
		{
			*p = d;
			++p;
			if(p >= p0 + m_size)
			{
				full = true;
				p = p0;
			}
			cnt++;
		}
	}

	//       (
	//      ,  
	//  ).
	Data *first() volatile
	{
		if(!full)
			return (p == p0) ? 0 : p0;

		return p;
	}

	//        (
	//      ,  
	//  ).
	Data *last() volatile
	{
		if(!full)
			return (p == p0) ? 0 : p-1;
		Data *px = p - 1;
		if(px < p0)
			px += m_size;
		return px;
	}
};

//         
//   .
class PipState
{
public:
	//      .
	volatile uint16_t m_cnt_prev;

	//     .
	volatile uint16_t m_capt;

	//      .
	volatile uint16_t n_cnt_prev;

	//       ,
	//   .
	volatile uint32_t m_corr;

	//       
	//  .
	volatile uint32_t n_corr;
};


// ***************************************************************
//  ,    
//  .
// ***************************************************************

//      .
PipState pip1;

//      .
PipState pip2;

//        
//   (   , 32-
// ).
//       .
volatile uint32_t m_capt = 0;
volatile uint32_t n_capt = 0;

//      (   
//        
// ;     ;  
//       ).
volatile DBuf dbuf;

//        
//      .
// ***     (  
//   TIM6  TIM7).
void _update_fm_vars(
		TIM_TypeDef *TIMm,	//  -   . .
		TIM_TypeDef *TIMn,	//  -  . . .
		PipState *state		//    .
		)
{
	//        
	//   ( :   , 
	//  ).

	//  ,    .
	// ! ,  ,   
	//      TIMm,    
	//   TIMn,    m_ccr1  n_ccr1 
	//  (    ).
	//     ,      
	// ,    ,   
	//   .
	uint32_t m_ccr1 = TIMm->CCR1;
	uint32_t n_ccr1 = TIMn->CCR1;

	//       
	//    ,    .
	uint32_t m_cnt = TIMm->CNT;
	uint32_t n_cnt = TIMn->CNT;

	//        
	//    (   
	// , ,  ;  
	//    ,    
	//    ,  ""  ).
	bool m_ovf = m_cnt < state->m_cnt_prev;
	bool n_ovf = n_cnt < state->n_cnt_prev;

	state->m_cnt_prev = m_cnt;
	state->n_cnt_prev = n_cnt;

	//        
	//  ( ,    
	//  TIM1,    ).
	bool captf = (m_ccr1 != state->m_capt);

	//   ,    
	//   .
	if(captf)
	{
		state->m_capt = m_ccr1;

		//     -   
		//    ;  -  ,
		//    (   ).
		uint32_t m_capt_corr = state->m_corr;
		uint32_t n_capt_corr = state->n_corr;
		if(m_ovf && m_ccr1 <= m_cnt)
			m_capt_corr += CNT_OVR;
		if(n_ovf && n_ccr1 <= n_cnt)
			n_capt_corr += CNT_OVR;

		//      .
		m_capt = m_ccr1 + m_capt_corr;
		n_capt = n_ccr1 + n_capt_corr;
	}

	//      ,  
	//  .
	if(m_ovf)
		state->m_corr += CNT_OVR;
	if(n_ovf)
		state->n_corr += CNT_OVR;
}

//     TIM6;
//   TIM6    _update_fm_vars;
//    ,      
//       TIMn 
// TIMm,       
//         .
// ***       TIMm, TIMn
//        
//   .       
//   .
extern "C" void TIM6_DAC_IRQHandler()
{
	if(TIM6->SR & TIM_SR_UIF)
	{
		TIM6->SR = ~TIM_SR_UIF;

		_update_fm_vars(TIM4, TIM1, &pip1);
		_update_fm_vars(TIM15, TIM2, &pip2);
	}
}

//     TIM7.
//   TIM7   -   
//  (      ).
//       , 
//     ,   .
extern "C" void TIM7_IRQHandler()
{
	TIM7->SR = ~TIM_SR_UIF;

	//      , 
	//  1  TIM4 (    ).
	TIM4->CCER &= ~TIM_CCER_CC1E;

	//       .
	_update_fm_vars(TIM4, TIM1, &pip1);

	//     (  
	//  -    ,   
	//     TIM6,   
	// ).
	TIM4->CCER |= TIM_CCER_CC1E;

	//         
	// (    , 
	//            
	//    ).
	TIM15->CCER &= ~TIM_CCER_CC1E;

	//       .
	_update_fm_vars(TIM15, TIM2, &pip2);

	//     (  
	//  -    ,   
	//     TIM6,   
	// ).
	TIM15->CCER |= TIM_CCER_CC1E;

	//    ,  
	//   m_capt, n_capt,   
	//   .
	// ,       
	// ,    (
	//           
	//  ).

	//     (  
	//  ).
	uint32_t n0 = 0;
	if(dbuf.size() > 0)
		n0 = dbuf.first()->n;

	dbuf.push({m_capt, n_capt});

	//       
	//  (      
	//      ).
	const Data *p1 = dbuf.first();
	if(p1->m != 0 && dbuf.is_full())
		dbuf.is_ready = true;

	//     dbuf.first()->n
	if(n0 > p1->n)
		dbuf.c0++;
}

//      
//   MCU;     
// ; ,     
//      (  ).
void fm_init()
{
	//  NVIC:    
	//    .

	//     ,  
	//  ,  ,    
	//     !

	//     (   
	// ,   ,    - 
	//      , 
	//        
	//   ).
	//   0,  (1 << __NVIC_PRIO_BITS) - 1
	const uint32_t level=0;

	NVIC_SetPriority(TIM6_DAC_IRQn, level);
	NVIC_SetPriority(TIM7_IRQn, level);

	NVIC_EnableIRQ(TIM6_DAC_IRQn);
	NVIC_EnableIRQ(TIM7_IRQn);

	//      .
	RCC->APB1ENR |=
			RCC_APB1ENR_TIM2EN |
			RCC_APB1ENR_TIM3EN |
			RCC_APB1ENR_TIM4EN |
			RCC_APB1ENR_TIM6EN |
			RCC_APB1ENR_TIM7EN;
	RCC->APB2ENR |=
			RCC_APB2ENR_IOPDEN |
			RCC_APB2ENR_TIM1EN |
			RCC_APB2ENR_TIM15EN;


	//   PD2 (TIM3_ETR)
	// (    ).
	GPIOD->CRL =
			GPIOD->CRL & ~0xF00 | 0x800;

	//    TIM6, TIM7.

	TIM6->ARR = 0x7FFF;
	TIM6->DIER |= TIM_DIER_UIE;

	TIM7->CR1 |= TIM_CR1_URS;
	TIM7->DIER |= TIM_DIER_UIE;
}

//  .
void fm_stop()
{
	//     TIM7, TIM6.
	TIM7->CR1 &= ~TIM_CR1_CEN;
	TIM6->CR1 &= ~TIM_CR1_CEN;

	//      
	// TIM1, TIM2, TIM3, TIM4, TIM15.
	const uint32_t rst1 =
			RCC_APB1RSTR_TIM2RST |
			RCC_APB1RSTR_TIM3RST |
			RCC_APB1RSTR_TIM4RST;
	const uint32_t rst2 =
			RCC_APB2RSTR_TIM1RST |
			RCC_APB2RSTR_TIM15RST;
	RCC->APB1RSTR |= rst1;
	RCC->APB2RSTR |= rst2;
	RCC->APB1RSTR &= ~rst1;
	RCC->APB2RSTR &= ~rst2;
}

//   (    ).
// timer_div1, timer_div2   ,
//   timer_div1*timer_div2/SystemCoreClock, 
// timer_div1=1..65536; timer_div2=2..65536.
// k -      , ,
//    
// k*timer_div1*timer_div2/SystemCoreClock
//      ,  ,
//  false.
//    ,  k     
//      k   
//  RAM    .
bool fm_start(uint32_t timer_div1, uint32_t timer_div2, uint32_t k)
{
	//    .
	if(timer_div1 - 1 > 0xFFFF || timer_div2 - 2 > 0xFFFE || k == 0)
		return false;

	//  ,   .
	if(TIM3->CR1 & TIM_CR1_CEN)
		fm_stop();

	//   .
	pip1 = {0, 0, 0, 0, 0};
	pip2 = pip1;
	m_capt = 0;
	n_capt = 0;

	dbuf.reset(k + 1);

	//    .

	//    TIM1, TIM2.
	//   .
	TIM1->CNT = 0;
	TIM2->CNT = 0;
	//       ( TIM4_TRGO);
	//       
	//  .
	//      ( TS  
	//    SMS).
	TIM1->SMCR |= 0x30;	// TS=011, TS: ITR3 (  TIM4_TRGO)
	TIM1->SMCR |= 0x6;	// SMS=110, Trigger Mode

	//  TIM2.
	TIM2->SMCR |= 0x30;	// TS=011, TS: ITR3 (  TIM4_TRGO)
	TIM2->SMCR |= 0x6;	// SMS=110, Trigger Mode

	//  TIM4->CR2, MMS=0, .. TRGO=Reset (the UG bit from the
	// TIMx_EGR register is used as trigger output).
	TIM4->EGR = TIM_EGR_UG;		// TIM1, TIM2   .

	//    TIM1  TIM2    
	// .
	TIM1->SMCR &= ~0x7;	// SMS=000
	TIM1->CCMR1 |= 3;	// CC1S=11: IC2 is mapped on TRC
	TIM1->CCER |= TIM_CCER_CC1E;	//    .

	TIM2->SMCR &= ~0x7;	// SMS=000
	TIM2->SMCR =		// TS=001, TS: ITR2 (TIM15_TRGO)
			TIM2->SMCR & ~0x70 |
			0x10;
	TIM2->CCMR1 |= 3;	// CC1S=11: IC2 is mapped on TRC
	TIM2->CCER |= TIM_CCER_CC1E;	//    .

	//   TIM4, TIM15.
	//        TIM3,
	//     TIM4, TIM15  .
	TIM4->CNT = 1;
	TIM4->SMCR |= 0x20;		// TS=010, ITR2 (TIM3_TRGO)
	TIM4->SMCR |= 0x7;		// SMS=111, External Clock Mode 1
	TIM4->CR2 |= 0x30;		// MMS=011, TRGO = Compare Pulse
	TIM4->CCMR1 |= 0x3;		// CC1S=11, IC1=TRC (ITR2 - TIM3_TRGO)
	TIM4->CR1 |= TIM_CR1_CEN;		// .
	TIM4->CCER |= TIM_CCER_CC1E;	//  .

	TIM15->CNT = 1;
	TIM15->SMCR |= 0x10;	// TS=001, ITR1 (TIM3_TRGO)
	TIM15->SMCR |= 0x7;		// SMS=111, External Clock Mode 1
	TIM15->CR2 |= 0x30;		// MMS=011, TRGO = Compare Pulse
	TIM15->CCMR1 |= 0x3;	// CC1S=11, IC1=TRC (ITR1 - TIM3_TRGO)
	TIM15->CR1 |= TIM_CR1_CEN;		// .
	TIM15->CCER |= TIM_CCER_CC1E;	//  .

	//  TIM3     
	// (   8).
	TIM3->CNT = 0;
	TIM3->ARR = 1;
	TIM3->CR2 |= 0x20;	// MMS=010, TRGO = Update
	TIM3->SMCR |=
			TIM_SMCR_ECE |	// External clock mode 2
			0x2000;			// ETPS=10, div=4
	TIM3->CR1 |= TIM_CR1_CEN;

	//   TIM6, TIM7.
	TIM6->CNT = 0;
	TIM6->CR1 |= TIM_CR1_CEN;

	TIM7->PSC = timer_div1 - 1;
	TIM7->EGR = TIM_EGR_UG;
	TIM7->ARR = timer_div2 - 1;
	TIM7->CR1 |= TIM_CR1_CEN;

	return true;
}

//       
// (       ).
//     ,  
//   , ..      
//    ;   
//    dbuf.is_ready   
// dbuf.get_cnt().
//      ,     
//   .
//    ,   :
// m -       ;
// n -     ( ) 
//  ;
// cnt -      (  
//   ,       
//      );
// c0 -   32-    
//       
//      ,  
//  m  n (     
//  ;    ).
//   false    (  
//  -        ).
bool get_result(uint32_t &m, uint32_t &n, uint32_t &cnt, uint32_t &c0)
{
	m = 0;
	n = 0;
	cnt = dbuf.get_cnt();
	c0 = dbuf.c0;
	bool r = dbuf.is_ready;
	if(r)
	{
		__disable_irq();
		cnt = dbuf.get_cnt();
		c0 = dbuf.c0;
		volatile const Data *p1 = dbuf.first();
		volatile const Data *p2 = dbuf.last();
		m = p2->m - p1->m;
		n = p2->n - p1->n;
		__enable_irq();
	}
	return r;
}

//      PB9 (TIM17, CH1).
//    .
//    
// fg=SystemCoreClock/(2*(psc+1)*(arr+1)),
// psc      0..65535;
// arr      1..65535;
// ph0 -        
//  0..65535.
float test_gen(uint16_t psc, uint16_t arr, uint16_t ph0)
{
	static bool init = true;
	if(init)
	{
		init = false;

		RCC->APB2ENR |= RCC_APB2ENR_TIM17EN;
		RCC->APB2ENR|=RCC_APB2ENR_IOPBEN;
		GPIOB->CRH =
				GPIOB->CRH & ~0x000000F0|
							  0x000000B0;

		TIM17->CCMR1=0x30; // toggle mode for OC1REF
		TIM17->CCER|=TIM_CCER_CC1E;	//  .
		TIM17->BDTR|=TIM_BDTR_MOE;
	}

	float res = SystemCoreClock / 2 / (float)((psc + 1) * (arr + 1));
	TIM17->CR1 &= ~TIM_CR1_CEN;
	TIM17->PSC = psc;
	TIM17->EGR = TIM_EGR_UG;
	TIM17->ARR = arr;
	TIM17->CCR1 = (arr + 1) >> 1;
	TIM17->CNT = ph0 % (arr + 1);

	TIM17->CR1 |= TIM_CR1_CEN;
	return res;
}

int main()
{
	//   .
	test_gen(0, 1500-1, 750);
	
	//  .
	keyboard_init();
	display_init();
	fm_init();

	//  .
	//   0.1; 5    , ..
	//    0.5.
	//      ,   
	//     .
	fm_start(240, 10000, 5);
	
	//   ;    
	//  1.
	SysTick_Config(SystemCoreClock/1000);

	while(true)
	{}
		//__WFI();	//     
					//  .

	//    main,   return .
	// return 0;
}
